    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2006, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------
    028     * ArrowNeedle.java
    029     * ----------------
    030     * (C) Copyright 2002-2006, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * $Id: ArrowNeedle.java,v 1.3.2.3 2006/08/02 10:40:57 mungady Exp $
    037     *
    038     * Changes:
    039     * --------
    040     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    041     * 27-Mar-2003 : Implemented Serializable (DG);
    042     * 09-Sep-2003 : Added equals() method (DG);
    043     * 08-Jun-2005 : Implemented Cloneable (DG);
    044     */
    045
    046    package org.jfree.chart.needle;
    047
    048    import java.awt.Graphics2D;
    049    import java.awt.Shape;
    050    import java.awt.geom.GeneralPath;
    051    import java.awt.geom.Line2D;
    052    import java.awt.geom.Point2D;
    053    import java.awt.geom.Rectangle2D;
    054    import java.io.Serializable;
    055
    056    /**
    057     * A needle in the shape of an arrow.
    058     */
    059    public class ArrowNeedle extends MeterNeedle
    060                             implements Cloneable, Serializable {
    061
    062        /** For serialization. */
    063        private static final long serialVersionUID = -5334056511213782357L;
    064
    065        /**
    066         * A flag controlling whether or not there is an arrow at the top of the
    067         * needle.
    068         */
    069        private boolean isArrowAtTop = true;
    070
    071        /**
    072         * Constructs a new arrow needle.
    073         *
    074         * @param isArrowAtTop  a flag that controls whether or not there is an
    075         *                      arrow at the top of the needle.
    076         */
    077        public ArrowNeedle(boolean isArrowAtTop) {
    078            this.isArrowAtTop = isArrowAtTop;
    079        }
    080
    081        /**
    082         * Draws the needle.
    083         *
    084         * @param g2  the graphics device.
    085         * @param plotArea  the plot area.
    086         * @param rotate  the rotation point.
    087         * @param angle  the angle.
    088         */
    089        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    090                                  Point2D rotate, double angle) {
    091
    092            Line2D shape = new Line2D.Float();
    093            Shape d = null;
    094
    095            float x = (float) (plotArea.getMinX() +  (plotArea.getWidth() / 2));
    096            float minY = (float) plotArea.getMinY();
    097            float maxY = (float) plotArea.getMaxY();
    098            shape.setLine(x, minY, x, maxY);
    099
    100            GeneralPath shape1 = new GeneralPath();
    101            if (this.isArrowAtTop) {
    102                shape1.moveTo(x, minY);
    103                minY += 4 * getSize();
    104            }
    105            else {
    106                shape1.moveTo(x, maxY);
    107                minY = maxY - 4 * getSize();
    108            }
    109            shape1.lineTo(x + getSize(), minY);
    110            shape1.lineTo(x - getSize(), minY);
    111            shape1.closePath();
    112
    113            if ((rotate != null) && (angle != 0)) {
    114                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    115                d = getTransform().createTransformedShape(shape);
    116            }
    117            else {
    118                d = shape;
    119            }
    120            defaultDisplay(g2, d);
    121
    122            if ((rotate != null) && (angle != 0)) {
    123                d = getTransform().createTransformedShape(shape1);
    124            }
    125            else {
    126                d = shape1;
    127            }
    128            defaultDisplay(g2, d);
    129
    130        }
    131
    132        /**
    133         * Tests another object for equality with this object.
    134         *
    135         * @param obj  the object to test (<code>null</code> permitted).
    136         *
    137         * @return A boolean.
    138         */
    139        public boolean equals(Object obj) {
    140            if (obj == this) {
    141                return true;
    142            }
    143            if (!(obj instanceof ArrowNeedle)) {
    144                return false;
    145            }
    146            if (!super.equals(obj)) {
    147                return false;
    148            }
    149            ArrowNeedle that = (ArrowNeedle) obj;
    150            if (this.isArrowAtTop != that.isArrowAtTop) {
    151                return false;
    152            }
    153            return true;
    154        }
    155
    156        /**
    157         * Returns a clone of this needle.
    158         *
    159         * @return A clone.
    160         *
    161         * @throws CloneNotSupportedException if the <code>ArrowNeedle</code>
    162         *     cannot be cloned (in theory, this should not happen).
    163         */
    164        public Object clone() throws CloneNotSupportedException {
    165            return super.clone();
    166        }
    167
    168    }